{
  Solutions to the Advent Of Code.
  Copyright (C) 2023-2024  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UNumberTheory;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Generics.Collections, Math;

type

  { TNumberTheory }

  TNumberTheory = class
  public
    class function GreatestCommonDivisor(AValue1, AValue2: Int64): Int64;
    class function LeastCommonMultiple(AValue1, AValue2: Int64): Int64;
  end;

implementation

{ TNumberTheory }

class function TNumberTheory.GreatestCommonDivisor(AValue1, AValue2: Int64): Int64;
var
  t: Int64;
begin
  AValue1 := Abs(AValue1);
  AValue2 := Abs(AValue2);
  while AValue2 <> 0 do
  begin
    t := AValue2;
    AValue2 := AValue1 mod AValue2;
    AValue1 := t;
  end;
  Result := AValue1;
end;

class function TNumberTheory.LeastCommonMultiple(AValue1, AValue2: Int64): Int64;
begin
  Result := (Abs(AValue1) div GreatestCommonDivisor(AValue1, AValue2)) * Abs(AValue2);
end;

end.

