{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UCamelCardsTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UCamelCards;

type

  { TCamelCardsFullDataTestCase }

  TCamelCardsFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

  { TCamelCardsExampleTestCase }

  TCamelCardsExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TCamelCardsFullDataTestCase }

function TCamelCardsFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TCamelCards.Create;
end;

procedure TCamelCardsFullDataTestCase.TestPart1;
begin
  AssertEquals(254024898, FSolver.GetResultPart1);
end;

procedure TCamelCardsFullDataTestCase.TestPart2;
begin
  AssertEquals(254115617, FSolver.GetResultPart2);
end;

{ TCamelCardsExampleTestCase }

function TCamelCardsExampleTestCase.CreateSolver: ISolver;
begin
  Result := TCamelCards.Create;
end;

procedure TCamelCardsExampleTestCase.TestPart1;
begin
  AssertEquals(6440, FSolver.GetResultPart1);
end;

procedure TCamelCardsExampleTestCase.TestPart2;
begin
  AssertEquals(5905, FSolver.GetResultPart2);
end;

initialization

  RegisterTest('TCamelCards', TCamelCardsFullDataTestCase);
  RegisterTest('TCamelCards', TCamelCardsExampleTestCase);
end.
