{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UFloorWillBeLavaTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UFloorWillBeLava;

type

  { TFloorWillBeLavaFullDataTestCase }

  TFloorWillBeLavaFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

  { TFloorWillBeLavaExampleTestCase }

  TFloorWillBeLavaExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TFloorWillBeLavaFullDataTestCase }

function TFloorWillBeLavaFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TFloorWillBeLava.Create;
end;

procedure TFloorWillBeLavaFullDataTestCase.TestPart1;
begin
  AssertEquals(7392, FSolver.GetResultPart1);
end;

procedure TFloorWillBeLavaFullDataTestCase.TestPart2;
begin
  AssertEquals(7665, FSolver.GetResultPart2);
end;

{ TFloorWillBeLavaExampleTestCase }

function TFloorWillBeLavaExampleTestCase.CreateSolver: ISolver;
begin
  Result := TFloorWillBeLava.Create;
end;

procedure TFloorWillBeLavaExampleTestCase.TestPart1;
begin
  AssertEquals(46, FSolver.GetResultPart1);
end;

procedure TFloorWillBeLavaExampleTestCase.TestPart2;
begin
  AssertEquals(51, FSolver.GetResultPart2);
end;

initialization

  RegisterTest('TFloorWillBeLava', TFloorWillBeLavaFullDataTestCase);
  RegisterTest('TFloorWillBeLava', TFloorWillBeLavaExampleTestCase);
end.

