{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UMirageMaintenanceTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UMirageMaintenance;

type

  { TMirageMaintenanceFullDataTestCase }

  TMirageMaintenanceFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

  { TMirageMaintenanceExampleTestCase }

  TMirageMaintenanceExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TMirageMaintenanceFullDataTestCase }

function TMirageMaintenanceFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TMirageMaintenance.Create;
end;

procedure TMirageMaintenanceFullDataTestCase.TestPart1;
begin
  AssertEquals(1877825184, FSolver.GetResultPart1);
end;

procedure TMirageMaintenanceFullDataTestCase.TestPart2;
begin
  AssertEquals(1108, FSolver.GetResultPart2);
end;

{ TMirageMaintenanceExampleTestCase }

function TMirageMaintenanceExampleTestCase.CreateSolver: ISolver;
begin
  Result := TMirageMaintenance.Create;
end;

procedure TMirageMaintenanceExampleTestCase.TestPart1;
begin
  AssertEquals(114, FSolver.GetResultPart1);
end;

procedure TMirageMaintenanceExampleTestCase.TestPart2;
begin
  AssertEquals(2, FSolver.GetResultPart2);
end;

initialization

  RegisterTest('TMirageMaintenance', TMirageMaintenanceFullDataTestCase);
  RegisterTest('TMirageMaintenance', TMirageMaintenanceExampleTestCase);
end.
