{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UParabolicReflectorDishTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UParabolicReflectorDish;

type

  { TParabolicReflectorDishFullDataTestCase }

  TParabolicReflectorDishFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

  { TParabolicReflectorDishExampleTestCase }

  TParabolicReflectorDishExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TParabolicReflectorDishFullDataTestCase }

function TParabolicReflectorDishFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TParabolicReflectorDish.Create;
end;

procedure TParabolicReflectorDishFullDataTestCase.TestPart1;
begin
  AssertEquals(103614, FSolver.GetResultPart1);
end;

procedure TParabolicReflectorDishFullDataTestCase.TestPart2;
begin
  AssertEquals(83790, FSolver.GetResultPart2);
end;

{ TParabolicReflectorDishExampleTestCase }

function TParabolicReflectorDishExampleTestCase.CreateSolver: ISolver;
begin
  Result := TParabolicReflectorDish.Create;
end;

procedure TParabolicReflectorDishExampleTestCase.TestPart1;
begin
  AssertEquals(136, FSolver.GetResultPart1);
end;

procedure TParabolicReflectorDishExampleTestCase.TestPart2;
begin
  AssertEquals(64, FSolver.GetResultPart2);
end;

initialization

  RegisterTest('TParabolicReflectorDish', TParabolicReflectorDishFullDataTestCase);
  RegisterTest('TParabolicReflectorDish', TParabolicReflectorDishExampleTestCase);
end.

