{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UPulsePropagationTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UPulsePropagation;

type

  { TPulsePropagationFullDataTestCase }

  TPulsePropagationFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

  { TPulsePropagationExampleTestCase }

  TPulsePropagationExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

  { TExample2PulsePropagation }

  TExample2PulsePropagation = class(TPulsePropagation)
    function GetDataFileName: string; override;
  end;

  { TPulsePropagationExample2TestCase }

  TPulsePropagationExample2TestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

implementation

{ TPulsePropagationFullDataTestCase }

function TPulsePropagationFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TPulsePropagation.Create;
end;

procedure TPulsePropagationFullDataTestCase.TestPart1;
begin
  AssertEquals(949764474, FSolver.GetResultPart1);
end;

{ TPulsePropagationExampleTestCase }

function TPulsePropagationExampleTestCase.CreateSolver: ISolver;
begin
  Result := TPulsePropagation.Create;
end;

procedure TPulsePropagationExampleTestCase.TestPart1;
begin
  AssertEquals(32000000, FSolver.GetResultPart1);
end;

{ TExample2PulsePropagation }

function TExample2PulsePropagation.GetDataFileName: string;
begin
  Result := 'pulse_propagation2.txt';
end;

{ TPulsePropagationExample2TestCase }

function TPulsePropagationExample2TestCase.CreateSolver: ISolver;
begin
  Result := TExample2PulsePropagation.Create;
end;

procedure TPulsePropagationExample2TestCase.TestPart1;
begin
  AssertEquals(11687500, FSolver.GetResultPart1);
end;

initialization

  RegisterTest('TPulsePropagation', TPulsePropagationFullDataTestCase);
  RegisterTest('TPulsePropagation', TPulsePropagationExampleTestCase);
  RegisterTest('TPulsePropagation', TPulsePropagationExample2TestCase);
end.

