{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit USandSlabsTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, USandSlabs;

type

  { TSandSlabsFullDataTestCase }

  TSandSlabsFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

  { TSandSlabsExampleTestCase }

  TSandSlabsExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TSandSlabsFullDataTestCase }

function TSandSlabsFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TSandSlabs.Create;
end;

procedure TSandSlabsFullDataTestCase.TestPart1;
begin
  AssertEquals(389, FSolver.GetResultPart1);
end;

procedure TSandSlabsFullDataTestCase.TestPart2;
begin
  AssertEquals(70609, FSolver.GetResultPart2);
end;

{ TSandSlabsExampleTestCase }

function TSandSlabsExampleTestCase.CreateSolver: ISolver;
begin
  Result := TSandSlabs.Create;
end;

procedure TSandSlabsExampleTestCase.TestPart1;
begin
  AssertEquals(5, FSolver.GetResultPart1);
end;

procedure TSandSlabsExampleTestCase.TestPart2;
begin
  AssertEquals(7, FSolver.GetResultPart2);
end;

initialization

  RegisterTest('TSandSlabs', TSandSlabsFullDataTestCase);
  RegisterTest('TSandSlabs', TSandSlabsExampleTestCase);
end.

