{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UStepCounterTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UStepCounter;

type

  { TStepCounterFullDataTestCase }

  TStepCounterFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

  { TStepCounterMax6ExampleTestCase }

  TStepCounterMax6ExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
  end;

implementation

{ TStepCounterFullDataTestCase }

function TStepCounterFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TStepCounter.Create;
end;

procedure TStepCounterFullDataTestCase.TestPart1;
begin
  AssertEquals(3809, FSolver.GetResultPart1);
end;

{ TStepCounterMax6ExampleTestCase }

function TStepCounterMax6ExampleTestCase.CreateSolver: ISolver;
begin
  Result := TStepCounter.Create(6);
end;

procedure TStepCounterMax6ExampleTestCase.TestPart1;
begin
  AssertEquals(16, FSolver.GetResultPart1);
end;

initialization

  RegisterTest('TStepCounter', TStepCounterFullDataTestCase);
  RegisterTest('TStepCounter', TStepCounterMax6ExampleTestCase);
end.

